const general = require('./generalFunctions');

exports.csvToNestedJson = function (json, csv, multiples, debug) {
    //display debug mode message
    if (!!debug == true)
        general.printInfo("DEBUG MDOE ON");


    // remove commas
    csv = removeCommas(csv);
    // get headers
    csvHeaders = csv.substring(0, csv.indexOf('\n')).split(',');
    csvBody = csv.substring(csv.indexOf('\n') + 1);
    // validate
    validate(csvBody, csvHeaders.length - 1);
    // get rows
    csvRows = getRows(csvBody);
    // fillup the json from the csv
    if (!!multiples) {
        map = new Map(Object.entries(json));
        newJson = {};
        map.forEach((value, key, map) => {
            newJson[key] = fetchAll(csvRows, csvHeaders, value);
        });
    }
    else json = fetchAll(csvRows, csvHeaders, json);

    return json;

}


const removeCommas = function (csv) {
    let i = 2;
    while (i < csv.length) {
        if (csv[i] == '\n' && csv[i - 1] == ',')
            csv = csv.slice(0, i - 1) + csv.slice(i, csv.length);
        else i++;
    }
    if (csv[csv.length - 1] == ',')
        csv = csv.slice(0, csv.length - 1);
    if (csv[csv.length - 1] == '\r')
        csv = csv.slice(0, csv.length - 1);
    return csv;
}

const validate = function (csvBody, commas) {

    let rows = 1;
    for (let i = 0, j = 0; i < csvBody.length; i++) {
        if (csvBody[i] == ',')
            j++;
        if (j > commas) {
            general.printError(`Too many commas in row ${rows} it should contain ${commas} but it contains ${j}.\n`);
            throw new Error;
        }
        if (csvBody[i] == '\n') {
            if (j < commas) {
                general.printError(`Too little commas in row ${rows} it should contain ${commas} but it contains ${j}.\n`);
                throw new Error;
            }
            j = 0, rows++;
        }
    }

}

const getRows = function (csvBody) {

    let lines = csvBody.split('\n');
    let rows = [];
    for (let i = 0; i < lines.length; i++)
        rows.push(lines[i].split(','));
    return rows;
}

const fetchAll = function (csvRows, csvHeaders, json) {
    for (let i = 0; i < csvRows.length; i++) {
        for (let j = 0; j < csvHeaders.length; j++) {
            json = fetch(csvRows[i][j], csvHeaders[j], json);
        }
    }
    return json;
}

const fetch = function (value, path, json) {

    if (value == undefined)
        return json;
    if (path.includes('.')) {
        let current = path.substring(0, path.indexOf('.'));
        let newPath = path.substring(path.indexOf('.') + 1, path.length);
        json[current] = fetch(value, newPath, json[current]);
        return json;
    }
    json[path] = value;
    return json;
}